#ifndef GRAPHE_HPP
#define GRAPHE_HPP

#include <cmath>
#include <iostream>
using namespace std;

class graphe {
  int n;
  int * d;
  int * A;
  int index_A(int i,int j){
    return i*n+j; 
  }
public:
  graphe(){
    n = 0;
    d = NULL;
    A = NULL;
  }
  graphe (int size){
    n =  size;
    d = new int[n];
    A = new int[n*n];
    for(int i=0;i<n;i++){
      d[i]=0.0;
      for(int j=0;j<n;j++){
        A[index_A(i,j)]=0;
      }
    }
  }
  graphe(const graphe & G){
    n = G.n;
    if( G.d!= NULL){
      d = new int[n];
      A = new int[n*n];
      for(int i=0;i<n;i++){
        d[i]=G.d[i];
        for(int j=0;j<n;j++){
          A[index_A(i,j)]=G.A[index_A(i,j)];
        }
      }
    }
  }
  ~graphe(){
    if(d!= NULL){
      delete [] d;
    } 
    if(A!= NULL){
      delete [] A;
    } 
  }
  graphe & operator =(const graphe & );
  double get_A(int, int);
  double get_d(int);
  void set_A(int,int,int);
  void set_d(int,int);
  graphe operator +(graphe );
  void construct_proba( double *);
  void modify_proba(double *, double);
  void product(double *, double *, double *);
  void compute_rank(double *, double *,int );
  
};
#endif
