#include <cmath>
#include <iostream>
using namespace std;

#include "graphe.hpp"

 graphe & graphe::operator =(const graphe & g){
   if (this != &g){
      if(A != NULL){
        delete [] A;
        delete [] d;
      }
      n = g.n;
      if( g.d!= NULL){
      d = new int[n];
      A = new int[n*n];
      for(int i=0;i<n;i++){
        d[i]=g.d[i];
        for(int j=0;j<n;j++){
          A[index_A(i,j)]=g.A[index_A(i,j)];
        }
      }
    }
   }
  return *this;
 }
 double graphe::get_A(int i, int j){
     return A[this->index_A(i,j)];
 }
  double graphe::get_d(int i){
     return d[i];
 }
  void graphe::set_A(int i,int j, int x){
    A[this->index_A(i,j)]=x;
  }
  void graphe::set_d(int i, int x){
     d[i]=x;
 }
  graphe graphe::operator +(graphe g) {
      graphe res(n);
      int loc_res=0;
      if (this->n != g.n){ cout<<"addition impossible"<<endl;exit(0);}
      else{
        for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
                if(g.A[index_A(i,j)] ==1  || this->A[index_A(i,j)] ==1){
                    res.A[index_A(i,j)]=1;
                }
            }
        }
         for(int j=0;j<n;j++){
            loc_res=0;
            for(int k=0;k<n;k++){
                loc_res= loc_res+res.A[index_A(k,j)];
            }
            res.d[j]=loc_res;
        }
      }
      return res;
  }

  void graphe::construct_proba(double * P){
       for(int i=0;i<n;i++){
            for(int j=0;j<n;j++){
              if(d[i]==0){
                P[index_A(i,j)]=1.0/n;
              } else {
                P[index_A(i,j)]=A[index_A(i,j)]/d[j];
              }
            }
        }

  }

  void graphe::modify_proba(double * P,double alpha){
      for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            P[index_A(i,j)]=alpha*P[index_A(i,j)]+(1-alpha)/n;
        }
      }
  }
  void graphe::product(double * A, double * b, double * x){
    for(int i=0;i<n;i++){
        for(int j=0;j<n;j++){
            x[i]=x[i]+A[index_A(i,j)]*b[j];
        }
      }
  }
  void graphe::compute_rank(double * P, double *r, int iter){
    double temp_r[n];
    for(int k=0;k<iter;k++){
      product(P,r,temp_r);
      for(int j=0;j<n;j++){
        r[j]=temp_r[j];
      }
    }
  }

